#include "r_syscall.h"

/* syscall-openbsd */
RSyscallItem syscalls_openbsd_x86[] = {
  { "syscall", 0x80, 0, 2 },
  { "exit", 0x80, 1, 1 },
  { "fork", 0x80, 2, 0 },
  { "read", 0x80, 3, 3 },
  { "write", 0x80, 4, 3 },
  { "open", 0x80, 5, 3 },
  { "close", 0x80, 6, 1 },
  { "wait4", 0x80, 7, 4 },
  { "link", 0x80, 9, 2 },
  { "unlink", 0x80, 10, 1 },
  { "chdir", 0x80, 12, 1 },
  { "fchdir", 0x80, 13, 1 },
  { "mknod", 0x80, 14, 3 },
  { "chmod", 0x80, 15, 2 },
  { "chown", 0x80, 16, 3 },
  { "break", 0x80, 17, 1 },
  { "getpid", 0x80, 20, 0 },
  { "mount", 0x80, 21, 4 },
  { "unmount", 0x80, 22, 2 },
  { "setuid", 0x80, 23, 1 },
  { "getuid", 0x80, 24, 0 },
  { "geteuid", 0x80, 25, 0 },
  { "ptrace", 0x80, 26, 4 },
  { "recvmsg", 0x80, 27, 3 },
  { "sendmsg", 0x80, 28, 3 },
  { "recvfrom", 0x80, 29, 6 },
  { "accept", 0x80, 30, 3 },
  { "getpeername", 0x80, 31, 3 },
  { "getsockname", 0x80, 32, 3 },
  { "access", 0x80, 33, 2 },
  { "chflags", 0x80, 34, 2 },
  { "fchflags", 0x80, 35, 2 },
  { "sync", 0x80, 36, 0 },
  { "kill", 0x80, 37, 2 },
  { "getppid", 0x80, 39, 0 },
  { "dup", 0x80, 41, 1 },
  { "opipe", 0x80, 42, 0 },
  { "getegid", 0x80, 43, 0 },
  { "profil", 0x80, 44, 4 },
  { "ktrace", 0x80, 45, 4 },
  { "sigaction", 0x80, 46, 3 },
  { "getgid", 0x80, 47, 0 },
  { "sigprocmask", 0x80, 48, 2 },
  { "getlogin", 0x80, 49, 2 },
  { "setlogin", 0x80, 50, 1 },
  { "acct", 0x80, 51, 1 },
  { "sigpending", 0x80, 52, 0 },
  { "osigaltstack", 0x80, 53, 2 },
  { "ioctl", 0x80, 54, 3 },
  { "reboot", 0x80, 55, 1 },
  { "revoke", 0x80, 56, 1 },
  { "symlink", 0x80, 57, 2 },
  { "readlink", 0x80, 58, 3 },
  { "execve", 0x80, 59, 3 },
  { "umask", 0x80, 60, 1 },
  { "chroot", 0x80, 61, 1 },
  { "vfork", 0x80, 66, 0 },
  { "sbrk", 0x80, 69, 1 },
  { "sstk", 0x80, 70, 1 },
  { "munmap", 0x80, 73, 2 },
  { "mprotect", 0x80, 74, 3 },
  { "madvise", 0x80, 75, 3 },
  { "mincore", 0x80, 78, 3 },
  { "getgroups", 0x80, 79, 2 },
  { "setgroups", 0x80, 80, 2 },
  { "getpgrp", 0x80, 81, 0 },
  { "setpgid", 0x80, 82, 2 },
  { "setitimer", 0x80, 83, 3 },
  { "getitimer", 0x80, 86, 2 },
  { "dup2", 0x80, 90, 2 },
  { "fcntl", 0x80, 92, 3 },
  { "select", 0x80, 93, 5 },
  { "fsync", 0x80, 95, 1 },
  { "setpriority", 0x80, 96, 3 },
  { "socket", 0x80, 97, 3 },
  { "connect", 0x80, 98, 3 },
  { "getpriority", 0x80, 100, 2 },
  { "sigreturn", 0x80, 103, 1 },
  { "bind", 0x80, 104, 3 },
  { "setsockopt", 0x80, 105, 5 },
  { "listen", 0x80, 106, 2 },
  { "sigsuspend", 0x80, 111, 1 },
  { "gettimeofday", 0x80, 116, 2 },
  { "getrusage", 0x80, 117, 2 },
  { "getsockopt", 0x80, 118, 5 },
  { "readv", 0x80, 120, 3 },
  { "writev", 0x80, 121, 3 },
  { "settimeofday", 0x80, 122, 2 },
  { "fchown", 0x80, 123, 3 },
  { "fchmod", 0x80, 124, 2 },
  { "setreuid", 0x80, 126, 2 },
  { "setregid", 0x80, 127, 2 },
  { "rename", 0x80, 128, 2 },
  { "flock", 0x80, 131, 2 },
  { "mkfifo", 0x80, 132, 2 },
  { "sendto", 0x80, 133, 6 },
  { "shutdown", 0x80, 134, 2 },
  { "socketpair", 0x80, 135, 4 },
  { "mkdir", 0x80, 136, 2 },
  { "rmdir", 0x80, 137, 1 },
  { "utimes", 0x80, 138, 2 },
  { "adjtime", 0x80, 140, 2 },
  { "setsid", 0x80, 147, 0 },
  { "quotactl", 0x80, 148, 4 },
  { "nfssvc", 0x80, 155, 2 },
  { "getfh", 0x80, 161, 2 },
  { "sysarch", 0x80, 165, 2 },
  { "pread", 0x80, 173, 5 },
  { "pwrite", 0x80, 174, 5 },
  { "setgid", 0x80, 181, 1 },
  { "setegid", 0x80, 182, 1 },
  { "seteuid", 0x80, 183, 1 },
  { "lfs_bmapv", 0x80, 184, 3 },
  { "lfs_markv", 0x80, 185, 3 },
  { "lfs_segclean", 0x80, 186, 2 },
  { "lfs_segwait", 0x80, 187, 2 },
  { "pathconf", 0x80, 191, 2 },
  { "fpathconf", 0x80, 192, 2 },
  { "swapctl", 0x80, 193, 3 },
  { "getrlimit", 0x80, 194, 2 },
  { "setrlimit", 0x80, 195, 2 },
  { "getdirentries", 0x80, 196, 4 },
  { "mmap", 0x80, 197, 7 },
  { "__syscall", 0x80, 198, 2 },
  { "lseek", 0x80, 199, 4 },
  { "truncate", 0x80, 200, 3 },
  { "ftruncate", 0x80, 201, 3 },
  { "__sysctl", 0x80, 202, 6 },
  { "mlock", 0x80, 203, 2 },
  { "munlock", 0x80, 204, 2 },
  { "futimes", 0x80, 206, 2 },
  { "getpgid", 0x80, 207, 1 },
  { "nnpfspioctl", 0x80, 208, 5 },
  { "semget", 0x80, 221, 3 },
  { "msgget", 0x80, 225, 2 },
  { "msgsnd", 0x80, 226, 4 },
  { "msgrcv", 0x80, 227, 5 },
  { "shmat", 0x80, 228, 3 },
  { "shmdt", 0x80, 230, 1 },
  { "clock_gettime", 0x80, 232, 2 },
  { "clock_settime", 0x80, 233, 2 },
  { "clock_getres", 0x80, 234, 2 },
  { "nanosleep", 0x80, 240, 2 },
  { "minherit", 0x80, 250, 3 },
  { "rfork", 0x80, 251, 1 },
  { "poll", 0x80, 252, 3 },
  { "issetugid", 0x80, 253, 0 },
  { "lchown", 0x80, 254, 3 },
  { "getsid", 0x80, 255, 1 },
  { "msync", 0x80, 256, 3 },
  { "pipe", 0x80, 263, 1 },
  { "fhopen", 0x80, 264, 2 },
  { "preadv", 0x80, 267, 5 },
  { "pwritev", 0x80, 268, 5 },
  { "kqueue", 0x80, 269, 0 },
  { "kevent", 0x80, 270, 6 },
  { "mlockall", 0x80, 271, 1 },
  { "munlockall", 0x80, 272, 0 },
  { "getpeereid", 0x80, 273, 3 },
  { "getresuid", 0x80, 281, 3 },
  { "setresuid", 0x80, 282, 3 },
  { "getresgid", 0x80, 283, 3 },
  { "setresgid", 0x80, 284, 3 },
  { "mquery", 0x80, 286, 7 },
  { "closefrom", 0x80, 287, 1 },
  { "sigaltstack", 0x80, 288, 2 },
  { "shmget", 0x80, 289, 3 },
  { "semop", 0x80, 290, 3 },
  { "stat", 0x80, 291, 2 },
  { "fstat", 0x80, 292, 2 },
  { "lstat", 0x80, 293, 2 },
  { "fhstat", 0x80, 294, 2 },
  { "__semctl", 0x80, 295, 4 },
  { "shmctl", 0x80, 296, 3 },
  { "msgctl", 0x80, 297, 3 },
  { "sched_yield", 0x80, 298, 0 },
  { "getthrid", 0x80, 299, 0 },
  { "thrsleep", 0x80, 300, 4 },
  { "thrwakeup", 0x80, 301, 2 },
  { "threxit", 0x80, 302, 1 },
  { "thrsigdivert", 0x80, 303, 3 },
  { "__getcwd", 0x80, 304, 2 },
  { "adjfreq", 0x80, 305, 2 },
  { "getfsstat", 0x80, 306, 3 },
  { "statfs", 0x80, 307, 2 },
  { "fstatfs", 0x80, 308, 2 },
  { "fhstatfs", 0x80, 309, 2 },
  { "setrtable", 0x80, 310, 1 },
  { "getrtable", 0x80, 311, 0 },
  { NULL }
};
